'****************************************
'Declare Global Variables
'****************************************

Dim Installer, FileLocation, ScriptName, ScriptFunction
Dim Database, SQL, View, Record


'****************************************
'Set Global Objects and Script Properties
'****************************************
ScriptName      = "23_CompressedFilesInCabs.vbs"
ScriptFunction  =	"Fils marked as Compressed when Installation is itself compressed"

Set WshShell    =	CreateObject("WScript.Shell")
Set Installer   =	CreateObject("WindowsInstaller.Installer")
Set objFSO      = CreateObject("Scripting.FileSystemObject")

Appdata         = wshshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Local AppData")

Set Database    = Installer.OpenDatabase(Appdata &"\temp.msi", 1)

'****************************************
'Script Specific Objects
'****************************************

'****************************************
'Script Specific Variables
'****************************************

'****************************************
'Script 
'****************************************


'Firstly - we need to determine if the Summary Information Stream 
'is marked as compressed by default
Set streamobj = Database.SummaryInformation(0) '0 = read only
'WScript.Echo streamobj.Property(9)


propertylist = "0? =" &streamobj.Property(0) & vbNewline _
 & "?1 =" &streamobj.Property(1) & vbNewline _
 & "Subject =" &streamobj.Property(2) & vbNewline _
 & "Title = " & streamobj.Property(3)  & vbNewline _
 & "Author = " & streamobj.Property(4) & vbNewline _ 
 & "Keywords = " & streamobj.Property(5) & vbNewline _ 
 & "Comments = " & streamobj.Property(6) & vbNewline _ 
 & "Platform and Language = " &streamobj.Property(7) & vbNewline _ 
 & "Hidden - David Hacker = " &streamobj.Property(8) & vbNewline _ 
 & "PackageCode = " &streamobj.Property(9) & vbNewline _ 
  & "?10 =" &streamobj.Property(10) & vbNewline _
 & "Date Time Last Altered = " &streamobj.Property(11) & vbNewline _ 
   & "?12 =" &streamobj.Property(12) & vbNewline _
   & "?13 =" &streamobj.Property(13) & vbNewline _  
 & "Schema = " &streamobj.Property(14) & vbNewline _ 
 & "Wordcount = " &streamobj.Property(15) & vbNewline _ 
 & "? = " &streamobj.Property(16) & vbNewline _ 
 & "?  = " &streamobj.Property(17) & vbNewline _ 
 & "Hidden Created By Field = " &streamobj.Property(18) & vbNewline _ 
 & "?19 = " &streamobj.Property(19) & vbNewline _ 


WordCount = streamobj.Property(15)

		If streamobj.Property(15) AND 2 = 2 Then
      'We have to ensure that files aren't marked as compressed within the package
        SQL = 	"SELECT * FROM File"
        Set View = 	DataBase.OpenView(SQL)
        View.execute
        Set record = view.Fetch

        While Not (record Is Nothing)
          If 16384 = Record.IntegerData(7) AND 16384 Then
            'These files need to have their compressed flag removed
            'Msgbox "File marked as Compressed" &Record.StringData(1) 
            Record.IntegerData(7) = Record.IntegerData(7) - 16384
            View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
          end if
          Set record = view.Fetch
        Wend      
    end if
Database.Commit


Cleanup

'****************************************
'Functions
'****************************************

Function Cleanup
	'Set Objects to Nothing
	Set wshShell = Nothing
	Set Installer = Nothing
	Set View = Nothing	
	Set Record = Nothing	
  Set Database = Nothing
End Function