'****************************************
'Declare Global Variables
'****************************************

Dim Installer, FileLocation, ScriptName, ScriptFunction
Dim Database, SQL, View, Record


'****************************************
'Set Global Objects and Script Properties
'****************************************
ScriptName      = "24_AdvtExecute_UnpublishAssemblies.vbs"
ScriptFunction  = "Removes Unpublished Assemblies from AdvtExecute"

Set WshShell    =	CreateObject("WScript.Shell")
Set Installer   =	CreateObject("WindowsInstaller.Installer")
Set objFSO      = CreateObject("Scripting.FileSystemObject")

Appdata         = wshshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Local AppData")

Set Database    = Installer.OpenDatabase(Appdata &"\temp.msi", 1)

'****************************************
'Script Specific Objects
'****************************************

'****************************************
'Script Specific Variables
'****************************************

'****************************************
'Script 
'****************************************


'Firstly - we need to check for the existence of a AdvtExecuteSequence table

SQL = 	"SELECT * FROM _Tables"
Set View = 	DataBase.OpenView(SQL)
View.execute
Set record = view.Fetch

While Not (record Is Nothing)
		If Record.StringData(1) = "AdvtExecuteSequence" Then
			tablefound=1
		end if
    Set record = view.Fetch
Wend

if tablefound = 1 then
  'We have to ensure that no entry for MsiUnpublishAssemblies exists
  
    dbProperty="MsiUnpublishAssemblies"

    Set View = DataBase.OpenView("SELECT * FROM AdvtExecuteSequence WHERE Action = '" &dbProperty &"'")
    View.Execute
    Set Record = View.Fetch

    If Record Is Nothing Then 
      'Property Doesn't Exist - ... don't have to worry
    else
      'Property Does Exist - modify entry
      Set View = database.OpenView("DELETE FROM AdvtExecuteSequence WHERE `Action` = 'MsiUnpublishAssemblies'")
      view.Execute
      View.Close
    end if
  
else


end if


Database.Commit

Cleanup

'****************************************
'Functions
'****************************************


Function Cleanup
	'Set Objects to Nothing
	Set wshShell = Nothing
	Set Installer = Nothing
	Set View = Nothing	
	Set Record = Nothing	
  Set Database = Nothing
End Function