'****************************************
'Declare Global Variables
'****************************************

Dim Installer, CurrentFile, FileLocation, ScriptName, ScriptFunction
Dim Database, SQL, View, Record


'****************************************
'Set Global Objects and Script Properties
'****************************************
ScriptName      =	"80_ValidationTableEntries.vbs"
ScriptFunction  =	""

Set WshShell    =	CreateObject("WScript.Shell")
Set Installer   =	CreateObject("WindowsInstaller.Installer")
Set objFSO      = CreateObject("Scripting.FileSystemObject")

Appdata = wshshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Local AppData")
TempDir=WshShell.ExpandEnvironmentStrings("%TEMP%")

Set Database    = Installer.OpenDatabase(Appdata &"\temp.msi", 1)

'All columns are contained within the Columns table

SQL             = "SELECT * FROM _Columns"
Set View        =	DataBase.OpenView(SQL)
View.execute
Set record      = view.Fetch

ColumnCount = 0
While Not (record Is Nothing)
     ColumnCount = ColumnCount + 1
    Set record = view.Fetch
Wend

'msgbox "number of rows=" &ColumnCount

'setup an array with the same number of entries
'as the MSI 

Redim ColumnArray(ColumnCount - 1,3) 
ColumnCount = 0

Set View = 	DataBase.OpenView(SQL)
View.execute
Set record = view.Fetch


While Not (record Is Nothing)
	ColumnArray(ColumnCount,1)  = Record.StringData(1) 'Table
	ColumnArray(ColumnCount,2)  = Record.StringData(2) 'Column Number	
	ColumnArray(ColumnCount,3)  = Record.StringData(3) 'Column Name	
  ColumnCount = ColumnCount + 1
  Set record = view.Fetch
Wend


'Just incase, we'll export an IDT
  Database.Export "_Validation", TempDir &"\", "output.idt"
  set file = objFSO.OpenTextFile(TempDir &"\output.idt",8,,0) ' ForAppending   

'we need to recursively run checks against every every retrieved column and name
'to ensure that they are added to the Validation table

for x = 0 to ubound(ColumnArray)
  Set View = DataBase.OpenView("SELECT * FROM _Validation WHERE `Table` = '" & ColumnArray(x,1) &"' AND Column ='" &ColumnArray(x,3)  &"'")  
  View.Execute
  Set Record = View.Fetch
  If Record Is Nothing Then 
    'details must be added to _validation
  '   msgbox "must add " & ColumnArray(x,1) &" "& ColumnArray(x,3)  &" x= " &x &" to validation table"
     file.writeline(ColumnArray(x,1) &chr(09) &ColumnArray(x,3) &chr(09) &"Y" &chr(09) &chr(09) &chr(09) &chr(09) &chr(09) &chr(09) &chr(09))  
     changesmade=1
  else 
  end if
next


file.close
if changesmade=1 then
  Database.Import TempDir &"\", "output.idt"
  View.Execute
  Database.Commit  
end if



  Database.Import TempDir &"\", "output.idt"



Cleanup

'****************************************
'Functions
'****************************************



Function Cleanup
	'Set Objects to Nothing
	Set wshShell = Nothing
	Set Installer = Nothing
	Set View = Nothing	
	Set Record = Nothing	
  Set Database = Nothing
End Function