'****************************************
'Declare Global Variables
'****************************************

Dim Installer, FileLocation, ScriptName, ScriptFunction
Dim Database, SQL, View, Record


'****************************************
'Set Global Objects and Script Properties
'****************************************
ScriptName      =	"04 _ProductName"
ScriptFunction  =	"Set package name to containing directory Name"

Set WshShell    =	CreateObject("WScript.Shell")
Set Installer   =	CreateObject("WindowsInstaller.Installer")

Appdata         = wshshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Local AppData")
PackageName     = wshshell.RegRead("HKEY_CURRENT_USER\Software\MSIEdit\PackageName")
Set Database    = Installer.OpenDatabase(Appdata &"\temp.msi", 1)

'****************************************
'Script Specific Objects
'****************************************

'****************************************
'Script Specific Variables
'****************************************

'****************************************
'Script 
'****************************************


dbProperty  = "ProductName"
dbValue     = PackageName

Set View    = DataBase.OpenView("SELECT * FROM Property WHERE Property = '" &dbProperty &"'")
View.Execute
Set Record  = View.Fetch

If Record Is Nothing Then 
  'Property Doesn't Exist - Insert New Property
  Set View = DataBase.OpenView("INSERT INTO Property (Property, Value) VALUES ('" &dbProperty &"', '" &dbValue &"')")
  View.Execute
else
  'Property Does Exist - Modify Value
  Record.StringData(2) = dbValue
  View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
  View.Close
end if


Database.Commit


Cleanup

'****************************************
'Functions
'****************************************



Function Cleanup
	'Set Objects to Nothing
	Set wshShell = Nothing
	Set Installer = Nothing
	Set View = Nothing	
	Set Record = Nothing	
  Set Database = Nothing
End Function