'****************************************
'Declare Global Variables
'****************************************

Dim Installer, CurrentFile, FileLocation, ScriptName, ScriptFunction, TestResult
Dim ResultsKey, Message, Database, SQL, View, Record, Dispensation


'****************************************
'Set Global Objects and Script Properties
'****************************************
ScriptName = 		"18_MissingValidationTable.vbs"
ScriptFunction = 	"To inject Validation tables to AppDeploy Repackaged projects"

Set WshShell = 		CreateObject("WScript.Shell")
Set Installer = 	CreateObject("WindowsInstaller.Installer")
Set objFSO =      CreateObject("Scripting.FileSystemObject")

Appdata = wshshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Local AppData")

Set Database = Installer.OpenDatabase(Appdata &"\temp.msi", 1)

'****************************************
'Script Specific Objects
'****************************************

'****************************************
'Script Specific Variables
'****************************************

'****************************************
'Script 
'****************************************
'We have to be sure that there is an Error table within the MSI.
SQL = 	"SELECT * FROM _Tables"
Set View = 	DataBase.OpenView(SQL)
View.execute
Set record = view.Fetch

While Not (record Is Nothing)
		If Record.StringData(1) = "Error" Then
			tablefound=1
		end if
    Set record = view.Fetch
Wend

if tablefound = 1 then
  'We know we can carry on
else
  'We have to forcibly add a new table
    database.Import objFSO.GetFile(Wscript.ScriptFullName).ParentFolder &"\Resources"  , "Error.idt"
'    database.Commit 
'  	Wscript.quit
end if


Database.Commit


Cleanup

'****************************************
'Functions
'****************************************



Function Cleanup
	'Set Objects to Nothing
	Set wshShell = Nothing
	Set Installer = Nothing
	Set View = Nothing	
	Set Record = Nothing	
Set Database = Nothing
End Function