'****************************************
'Declare Global Variables
'****************************************

Dim Installer, FileLocation, ScriptName, ScriptFunction
Dim Database, SQL, View, Record


'****************************************
'Set Global Objects and Script Properties
'****************************************
ScriptName      = "25_InvalidFileVersionsError.vbs"
ScriptFunction  = "Remove Invalid File Versions"

Set WshShell    = CreateObject("WScript.Shell")
Set Installer   = CreateObject("WindowsInstaller.Installer")
Set objFSO      = CreateObject("Scripting.FileSystemObject")

Appdata         = wshshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Local AppData")

Set Database    = Installer.OpenDatabase(Appdata &"\temp.msi", 1)

'****************************************
'Script Specific Objects
'****************************************

'****************************************
'Script Specific Variables
'****************************************

'****************************************
'Script 
'****************************************

'We have to be sure that there is a File table within the MSI.
SQL         = 	"SELECT * FROM _Tables"
Set View    = 	DataBase.OpenView(SQL)
View.execute
Set record  = view.Fetch

While Not (record Is Nothing)
		If Record.StringData(1) = "File" Then
			tablefound=1
		end if
    Set record = view.Fetch
Wend

if tablefound = 1 then
  'We know we can carry on
else
    'Cant possibly be any errors
  	Wscript.quit
end if

        SQL = 	"SELECT * FROM File"
        Set View = 	DataBase.OpenView(SQL)
        View.execute
        Set record = view.Fetch

        While Not (record Is Nothing)
          If Record.Stringdata(5) = "65535.0.0.0" Then
            Record.Stringdata(5) = ""
            View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
          end if
          If Record.Stringdata(5) = "0.0.0.0" Then
            Record.Stringdata(5) = ""
            View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
          end if          

          Set record = view.Fetch
        Wend      

Database.Commit


Cleanup

'****************************************
'Functions
'****************************************


Function Cleanup
	'Set Objects to Nothing
	Set wshShell = Nothing
	Set Installer = Nothing
	Set View = Nothing	
	Set Record = Nothing	
  Set Database = Nothing
End Function