'****************************************
'Declare Global Variables
'****************************************

Dim Installer, FileLocation, ScriptName, ScriptFunction
Dim Database, SQL, View, Record


'****************************************
'Set Global Objects and Script Properties
'****************************************
ScriptName      = "54_ImageAttributesReserved.vbs"
ScriptFunction  = "Removes Attributes Reserved errors for Images in Dialogs"

Set WshShell    = CreateObject("WScript.Shell")
Set Installer   = CreateObject("WindowsInstaller.Installer")
Set objFSO      = CreateObject("Scripting.FileSystemObject")

Appdata         = wshshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Local AppData")

Set Database    = Installer.OpenDatabase(Appdata &"\temp.msi", 1)

'****************************************
'Script Specific Objects
'****************************************

'****************************************
'Script Specific Variables
'****************************************

'****************************************
'Script 
'****************************************

'We have to be sure that there is a Control table within the MSI.

SQL         = "SELECT * FROM _Tables"
Set View    = DataBase.OpenView(SQL)
View.execute
Set record  = view.Fetch

While Not (record Is Nothing)
		If Record.StringData(1) = "Control" Then
			tablefound=1
		end if
    Set record = view.Fetch
Wend

if tablefound = 1 then
  'We know we can carry on
else
    'Can't possibly be any errors
  	Wscript.quit
end if



SQL = 			"SELECT * FROM Control"
Set View = 		DataBase.OpenView(SQL)
View.execute

Set record = view.Fetch
While Not (record Is Nothing)

  'Bitmap Errors
  
  If Ucase(Record.StringData(3)) = "BITMAP" then 'type field - we want Bitmaps
    if Record.StringData(8) = 262145 then 'will generate attribute reserved error
        Record.StringData(8) ="1" 'Bitmaps have a set value
        View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
    end if        
  end if

  If Ucase(Record.StringData(3)) = "BITMAP" then 'type field - we want Bitmaps
    if Record.StringData(8) = 212144 then 'will generate attribute reserved error
        Record.StringData(8) ="1" 'Bitmaps have a set value
        View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
    end if        
  end if

  'Icon Errors
  
  If Ucase(Record.StringData(3)) = "ICON" then 'type field - we want Bitmaps
    if Record.StringData(8) = 4718593 then 'will generate attribute reserved error
        Record.StringData(8) = "5242881"
        View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
    end if        
  end if

  If Ucase(Record.StringData(3)) = "ICON" then 'type field - we want Bitmaps
    if Record.StringData(8) = 5767169 then 'will generate attribute reserved error
        Record.StringData(8) = "5242881"
        View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
    end if        
  end if

    Set record = view.Fetch
Wend

        View.Close
        Database.Commit

Cleanup

'****************************************
'Functions
'****************************************



Function Cleanup
	'Set Objects to Nothing
	Set wshShell = Nothing
	Set Installer = Nothing
	Set View = Nothing	
	Set Record = Nothing	
  Set Database = Nothing
End Function