'****************************************
'Declare Global Variables
'****************************************

Dim Installer, FileLocation, ScriptName, ScriptFunction
Dim Database, SQL, View, Record


'****************************************
'Set Global Objects and Script Properties
'****************************************
ScriptName      = "55_InvalidnstallerRegistryKeys.vbs"
ScriptFunction  = "Removes captured Darwin Descriptors and Installer Reg Keys"

Set WshShell    = CreateObject("WScript.Shell")
Set Installer   = CreateObject("WindowsInstaller.Installer")
Set objFSO      = CreateObject("Scripting.FileSystemObject")
Set oDict       = CreateObject("Scripting.Dictionary")


Appdata         = wshshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Local AppData")

Set Database    = Installer.OpenDatabase(Appdata &"\temp.msi", 1)

'****************************************
'Script Specific Objects
'****************************************

'****************************************
'Script Specific Variables
'****************************************

'****************************************
'Script 
'****************************************

'We have to be sure that there is a Registry table within the MSI.

SQL         = "SELECT * FROM _Tables"
Set View    = DataBase.OpenView(SQL)
View.execute
Set record  = view.Fetch

While Not (record Is Nothing)
		If Record.StringData(1) = "Registry" Then
			tablefound=1
		end if
    Set record = view.Fetch
Wend

if tablefound = 1 then
  'We know we can carry on
else
    'Can't possibly be any errors
  	Wscript.quit
end if


DictionaryKey = 0

SQL = 			"SELECT * FROM Registry"
Set View = 		DataBase.OpenView(SQL)
View.execute

Set record = view.Fetch
While Not (record Is Nothing)

  
  If Ucase(Record.IntegerData(2)) = 0  then 'HKCR
    if instr(Ucase(Record.StringData(3)), "INSTALLER\") = 1 then 'an msi has been recaptured\
        'we use a dictionary to record which registry entries need to be deleted
         'msgbox "adding bad key to dictionary"
        oDict.Add DictionaryKey , Record.StringData(1) 
        DictionaryKey  = DictionaryKey  + 1
    end if        
  end if

    Set record = view.Fetch
Wend

View.Close
     
'If there are any "bad" Registry Keys that shouldnt have been captured - they need to be removed.

a = oDict.Items
For i = 0 To oDict.Count - 1
    s = a(i)
    
    'msgbox oDict.Item(i)
      Set View = database.OpenView("DELETE FROM Registry WHERE `Registry` = '" & oDict.Item(i) & "'")
      view.Execute
      View.Close  
      Database.Commit     
Next 
 

'Cleanup

'****************************************
'Functions
'****************************************



Function Cleanup
	'Set Objects to Nothing
	Set wshShell = Nothing
	Set Installer = Nothing
	Set View = Nothing	
	Set Record = Nothing	
  Set Database = Nothing
End Function