'****************************************
'Declare Global Variables
'****************************************

Dim Installer, FileLocation, ScriptName, ScriptFunction
Dim Database, SQL, View, Record


'****************************************
'Set Global Objects and Script Properties
'****************************************
ScriptName      = "79_Workaround_SequenceOrder.vbs"
ScriptFunction  = "Sequence Order itself may add in additional Tables - this must occur before script 80 validation"


Set WshShell  = CreateObject("WScript.Shell")
Set Installer = CreateObject("WindowsInstaller.Installer")
Set objFSO    = CreateObject("Scripting.FileSystemObject")

Appdata       = wshshell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Local AppData")
TempDir       = WshShell.ExpandEnvironmentStrings("%TEMP%")

filelocation  = Appdata &"\temp.msi"

Set Database  = Installer.OpenDatabase(filelocation, 1) 'was 1

'****************************************
'Script Specific Objects
'****************************************

'****************************************
'Script Specific Variables
'****************************************

'****************************************
'Script 
'****************************************
'Have to ensure Sequence Tables are present
 tablefound = 0
SQL         = 	"SELECT * FROM _Tables"
Set View    = 	DataBase.OpenView(SQL)
View.execute
Set record  = view.Fetch

While Not (record Is Nothing)
		If Record.StringData(1) = "AdvtUISequence" Then
			AdvtUISequencetablefound=1
		end if
		
		If Record.StringData(1) = "AdminExecuteSequence" Then
			AdminExecuteSequencetablefound=1
		end if		
		
		If Record.StringData(1) = "InstallUISequence" Then
			AdminUISequencetablefound=1
		end if			

		If Record.StringData(1) = "AdminUISequence" Then
			AdminUISequencetablefound=1
		end if	
				
    Set record = view.Fetch
Wend


if InstallUISequencetablefound = 1 then
  'We know we can carry on
else
  'We have to forcibly add a new table
    database.Import objFSO.GetFile(Wscript.ScriptFullName).ParentFolder &"\Resources" , "InstallUISequence.idt"
    database.Commit 
end if

if AdvtUISequencetablefound = 1 then
  'We know we can carry on
else
  'We have to forcibly add a new table
    database.Import objFSO.GetFile(Wscript.ScriptFullName).ParentFolder &"\Resources" , "AdvtUISequence.idt"
    database.Commit 
end if


if AdminExecuteSequencetablefound = 1 then
  'We know we can carry on
else
  'We have to forcibly add a new table
    database.Import objFSO.GetFile(Wscript.ScriptFullName).ParentFolder &"\Resources" , "AdminExecuteSequence.idt"
    database.Commit 
end if


if AdminUISequencetablefound = 1 then
  'We know we can carry on
else
  'We have to forcibly add a new table
    database.Import objFSO.GetFile(Wscript.ScriptFullName).ParentFolder &"\Resources" , "AdminUISequence.idt"
    database.Commit 
end if

'******************************
'Admin Sequence
'******************************

  SQL = 			"SELECT * FROM AdminExecuteSequence ORDER by Sequence" 
  Set View = 		DataBase.OpenView(SQL)
  View.execute

  Set record = view.Fetch
  LastSequence = ""
  
  While Not (record Is Nothing) 
    If LastSequence ="" then 'dont bother about checking the last sequence
        LastSequence = Record.IntegerData(3) 
    else 'We do need to ensure that this value is higher than the last value referenced
      If Record.IntegerData(3) <= LastSequence then
        Record.IntegerData(3) = LastSequence + 1
        LastSequence = LastSequence + 1 'record what our last sequence number has been
          View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
        else
        LastSequence = Record.IntegerData(3) 
      end if
    end if
    Set record = view.Fetch   
  Wend
'next

View.Close
Database.Commit


  SQL = 			"SELECT * FROM AdminUISequence ORDER by Sequence" 
  Set View = 		DataBase.OpenView(SQL)
  View.execute

  Set record = view.Fetch
  LastSequence = ""
  
  While Not (record Is Nothing) 
    If LastSequence ="" then 'dont bother about checking the last sequence
        LastSequence = Record.IntegerData(3) 
    else 'We do need to ensure that this value is higher than the last value referenced
      If Record.IntegerData(3) <= LastSequence then
        Record.IntegerData(3) = LastSequence + 1
        LastSequence = LastSequence + 1 'record what our last sequence number has been
          View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
        else
        LastSequence = Record.IntegerData(3) 
      end if
    end if
    Set record = view.Fetch   
  Wend
'next

View.Close
Database.Commit


'******************************
'Advt Sequence
'******************************

  SQL = 			"SELECT * FROM AdvtExecuteSequence ORDER by Sequence" 
  Set View = 		DataBase.OpenView(SQL)
  View.execute

  Set record = view.Fetch
  LastSequence = ""
  
  While Not (record Is Nothing) 
    If LastSequence ="" then 'dont bother about checking the last sequence
        LastSequence = Record.IntegerData(3) 
    else 'We do need to ensure that this value is higher than the last value referenced
      If Record.IntegerData(3) <= LastSequence then
        Record.IntegerData(3) = LastSequence + 1
        LastSequence = LastSequence + 1 'record what our last sequence number has been
          View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
        else
        LastSequence = Record.IntegerData(3) 
      end if
    end if
    Set record = view.Fetch   
  Wend
'next

View.Close
Database.Commit


  SQL = 			"SELECT * FROM AdvtUISequence ORDER by Sequence" 
  Set View = 		DataBase.OpenView(SQL)
  View.execute

  Set record = view.Fetch
  LastSequence = ""
  
  While Not (record Is Nothing) 
    If LastSequence ="" then 'dont bother about checking the last sequence
        LastSequence = Record.IntegerData(3) 
    else 'We do need to ensure that this value is higher than the last value referenced
      If Record.IntegerData(3) <= LastSequence then
        Record.IntegerData(3) = LastSequence + 1
        LastSequence = LastSequence + 1 'record what our last sequence number has been
          View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
        else
        LastSequence = Record.IntegerData(3) 
      end if
    end if
    Set record = view.Fetch   
  Wend
'next

View.Close
Database.Commit



'******************************
'Advt Sequence
'******************************

  SQL = 			"SELECT * FROM InstallExecuteSequence ORDER by Sequence" 
  Set View = 		DataBase.OpenView(SQL)
  View.execute

  Set record = view.Fetch
  LastSequence = ""
  
  While Not (record Is Nothing) 
    If LastSequence ="" then 'dont bother about checking the last sequence
        LastSequence = Record.IntegerData(3) 
    else 'We do need to ensure that this value is higher than the last value referenced
      If Record.IntegerData(3) <= LastSequence then
        Record.IntegerData(3) = LastSequence + 1
        LastSequence = LastSequence + 1 'record what our last sequence number has been
          View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
        else
        LastSequence = Record.IntegerData(3) 
      end if
    end if
    Set record = view.Fetch   
  Wend
'next

View.Close
Database.Commit


  SQL = 			"SELECT * FROM InstallUISequence ORDER by Sequence" 
  Set View = 		DataBase.OpenView(SQL)
  View.execute

  Set record = view.Fetch
  LastSequence = ""
  
  While Not (record Is Nothing) 
    If LastSequence ="" then 'dont bother about checking the last sequence
        LastSequence = Record.IntegerData(3) 
    else 'We do need to ensure that this value is higher than the last value referenced
      If Record.IntegerData(3) <= LastSequence then
        Record.IntegerData(3) = LastSequence + 1
        LastSequence = LastSequence + 1 'record what our last sequence number has been
          View.Modify 2, Record 'Mode 2 = msiViewModifyUpdate
        else
        LastSequence = Record.IntegerData(3) 
      end if
    end if
    Set record = view.Fetch   
  Wend
'next

View.Close
Database.Commit


Cleanup

'****************************************
'Functions
'****************************************

Function Cleanup
	'Set Objects to Nothing
	Set wshShell = Nothing
	Set Installer = Nothing
	Set View = Nothing	
	Set Record = Nothing	
End Function