'***********************************
' Set Objects
'***********************************
Set oShell      = CreateObject("WScript.Shell")
Set objArgs     = WScript.Arguments
Set Installer   = CreateObject("WindowsInstaller.Installer")
Set oFso        = CreateObject("Scripting.FileSystemObject")

set oEnv = oShell.Environment("PROCESS")
     oEnv("SEE_MASK_NOZONECHECKS") = 1

Dim Sourcedir

Appdata          = oShell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\Local AppData")
MsiName          = oshell.RegRead("HKEY_CURRENT_USER\Software\MSIEdit\MSiName") 
TransformName    = oshell.RegRead("HKEY_CURRENT_USER\Software\MSIEdit\TransformName") 
SourceDir        = oshell.RegRead("HKEY_CURRENT_USER\Software\MSIEdit\SourceDir") 
PackageName      = oshell.RegRead("HKEY_CURRENT_USER\Software\MSIEdit\PackageName") 

'Mode Selection
ModeNewTransform  = oshell.RegRead("HKEY_CURRENT_USER\Software\MSIEdit\ModeNewTransform") 
ModeEditTransform = oshell.RegRead("HKEY_CURRENT_USER\Software\MSIEdit\ModeEditTransform") 
ModeEditMSI       = oshell.RegRead("HKEY_CURRENT_USER\Software\MSIEdit\ModeEditMSI") 


If (oFso.FileExists(Appdata &"\temp.msi")) Then
    oFso.DeleteFile(Appdata &"\temp.msi")
End If

If (oFso.FileExists(Appdata &"\temp.mst")) Then
    oFso.DeleteFile(Appdata &"\temp.mst")
End If


Set Database        =	Installer.OpenDatabase(SourceDir &MSIName, 1) 'Is to update the msi


if ModeEditMSI      = "True" then
  oFso.CopyFile SourceDir &MSIName , Appdata &"\temp.msi"
End if

if ModeNewTransform = "True" then
  oFso.CopyFile SourceDir &MSIName , Appdata &"\temp.msi"
End if



If ModeEditTransform = "True" then
    Database.ApplyTransform TransformName, 0
    
    oFso.CopyFile SourceDir &MSIName, Appdata &"\temp.msi"
		Set NewDatabase = Installer.OpenDatabase(Appdata &"\temp.msi", 1)

		NewDatabase.Merge Database, errorTable

		NewDatabase.Commit 	
End If



'there is no "close" routine for an opened database so we have to release the object
Set Database    = Nothing
Set NewDatabase = Nothing

'
'*************************************
'make our changes to the database
'This can be amended 
'*************************************

 varx=0
 set objf=oFso.GetFolder(oFso.GetFile(Wscript.ScriptFullName).ParentFolder)
    set fc=objf.files
    if fc.Count >1 then 
        For each fl in fc
          varx=varx+1
        Next
        varx=varx-1
        redim ScriptArray(varx)
        'now populate the array
        varx=0
        For each fl in fc
          ScriptArray(varx) = fl.name
          varx=varx+1
        Next        
    End If

  for i = UBound(ScriptArray) - 1 To 0 Step -1
    for j= 0 to i
        if ScriptArray(j)>ScriptArray(j+1) then
            temp=ScriptArray(j+1)
            ScriptArray(j+1)=ScriptArray(j)
            ScriptArray(j)=temp
        end if
    next
  next 
'end bubble sort.  Thanks Richard!

for varX = 0 to Ubound(ScriptArray)
    'Check for blank lines and ignore them
    If Len(ScriptArray(varX)) <> 0 Then
    
    Select Case ScriptArray(varX)
        Case "EditMSI.vbs"
        Case "MSIEditLauncher.exe"
        Case "MSIEditLauncher.pdb"
        Case "MSIEditLauncher.vshost.exe"
        Case "MSIEditLauncher.vshost.exe.manifest"
        Case ELSE 
              oShell.run chr(34) &oFso.GetFile(Wscript.ScriptFullName).ParentFolder &"\" &ScriptArray(varX) &chr(34), 1, true     
     End Select   
    End If
Next


'Open our Temporary Database so Transforms may be created
'Set Database = Installer.OpenDatabase(Appdata &"\temp.msi", 1)
'Set OriginalDatabase = Installer.OpenDatabase(SourceDir &MSIName, 0)


'We need to create Transforms (if required)
'Or Copy the Amended Database back into Position

if ModeEditMSI = "True" then
  'msgbox "copying transform - edit MSI mode"
	oFso.CopyFile Appdata &"\temp.msi" , SourceDir &MSIName , True
End if


if ModeNewTransform = "True" then
'Open our Temporary Database so Transforms may be created
  Set Database = Installer.OpenDatabase(Appdata &"\temp.msi", 1)
  Set OriginalDatabase = Installer.OpenDatabase(SourceDir &MSIName, 0)
  
  'msgbox "generating transform" & Appdata &"\temp.mst"
  Database.GenerateTransform OriginalDatabase , Appdata &"\temp.mst"
  
  'msgbox "summaryinfo" & Appdata &"\temp.mst"
	Database.CreateTransformSummaryInfo OriginalDatabase , Appdata &"\temp.mst", 0, 0' 
	Set OriginalDatabase = Nothing
  Set Database = Nothing   
  'msgbox "copying transform - new transform mode"  
  	oFso.CopyFile Appdata &"\temp.mst" , SourceDir  &PackageName &".mst" , True  
End if


If ModeEditTransform = "True" then
'Open our Temporary Database so Transforms may be created
  Set Database = Installer.OpenDatabase(Appdata &"\temp.msi", 1)
  Set OriginalDatabase = Installer.OpenDatabase(SourceDir &MSIName, 0)
  Database.GenerateTransform OriginalDatabase , Appdata &"\temp.mst"
	Database.CreateTransformSummaryInfo OriginalDatabase , Appdata &"\temp.mst", 0, 0'
	Set OriginalDatabase = Nothing
  Set Database = Nothing  
      oFso.CopyFile Appdata &"\temp.mst" , SourceDir  &PackageName &".mst" , True
End if



'***********************************
' Subroutines
'***********************************

Sub EnumDir(strdir)
    set f=oFso.GetFolder(strDir)
    set fc=f.files
    if fc.Count >1 then 
        For each fl in fc  
            Select Case fl.name 
                    Case "EditMSI.vbs"
                    Case ELSE 
                      oShell.run chr(34) &strdir &"\" &fl.name &chr(34), 1, true
            End Select

        Next
    End If
End Sub



function SortArray(arrShort)
    dim i, j, temp
    for i = UBound(arrShort) - 1 To 0 Step -1
      for j= 0 to i
        if arrShort(j)>arrShort(j+1) then
          temp=arrShort(j+1)
          arrShort(j+1)=arrShort(j)
          arrShort(j)=temp
         end if
       next
    next
    SortArray = arrShort
end function 

'***********************************
' Functions
'***********************************

Sub Cleanup
    Set Database = Nothing
    Set Installer = Nothing
    oEnv.Remove("SEE_MASK_NOZONECHECKS")
End Sub

